﻿Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.UF
Imports NXOpen.UI
Imports NXOpen.Annotations

Module NX85LimitsFits
    Dim s As Session = Session.GetSession()
    Dim ui As UI = UI.GetUI()
    Dim ufs As UFSession = UFSession.GetUFSession()
    Dim workPart As Part = s.Parts.Work
    Sub Main()
        Dim selecteddims(-1) As TaggedObject
        Dim response1 As Selection.Response = Selection.Response.Cancel
start1:
        response1 = Select_dims(selecteddims)

        EditDimensionTolerance(selecteddims)

end1:
    End Sub
    ' ----------------------------------------------
    '   sub to edit tolerance
    ' ----------------------------------------------
    Sub EditDimensionTolerance(ByVal selecteddims() As TaggedObject)
        Dim markId3 As Session.UndoMarkId
        Dim dimname1 As String = Nothing
        For Each dim1 As Dimension In selecteddims
            dimname1 = dim1.ToString()
            If dimname1.Contains("Radius") = True Then
                Dim radiusDimension1 As Annotations.RadiusDimension = dim1
                Dim linearTolerance1 As Annotations.LinearTolerance
                linearTolerance1 = radiusDimension1.GetTolerance()
                linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                radiusDimension1.SetTolerance(linearTolerance1)
                Dim dimensionPreferences1 As Annotations.DimensionPreferences
                dimensionPreferences1 = radiusDimension1.GetDimensionPreferences()
                dimensionPreferences1.LimitFitDeviation = "g"
                dimensionPreferences1.LimitFitGrade = 6
                radiusDimension1.SetDimensionPreferences(dimensionPreferences1)
            ElseIf dimname1.Contains("Horizontal") = True Then
                Dim horizontalDimension1 As Annotations.HorizontalDimension = dim1
                Dim linearTolerance1 As Annotations.LinearTolerance
                linearTolerance1 = horizontalDimension1.GetTolerance()
                linearTolerance1.ToleranceType = Annotations.ToleranceType.LimitsAndFits
                horizontalDimension1.SetTolerance(linearTolerance1)
                Dim dimensionPreferences1 As Annotations.DimensionPreferences
                dimensionPreferences1 = horizontalDimension1.GetDimensionPreferences()
                dimensionPreferences1.LimitFitDeviation = "G"
                dimensionPreferences1.LimitFitGrade = 6
                horizontalDimension1.SetDimensionPreferences(dimensionPreferences1)
            End If
        Next
        Dim nErrs1 As Integer
        nErrs1 = s.UpdateManager.DoUpdate(markId3)
    End Sub
    ' ----------------------------------------------
    '   function to select dimensions
    ' ----------------------------------------------
    Function Select_dims(ByRef obj() As TaggedObject) As Selection.Response
        Dim resp As Selection.Response = Selection.Response.Cancel
        Dim prompt As String = "Select dimensions"
        Dim message As String = "Select dimensions"
        Dim title As String = "Selection"
        Dim scope As Selection.SelectionScope = Selection.SelectionScope.WorkPart
        Dim selAction As Selection.SelectionAction = Selection.SelectionAction.ClearAndEnableSpecific
        Dim selectionMask_array(0) As Selection.MaskTriple
        Dim includeFeatures As Boolean = False
        Dim keepHighlighted As Boolean = False
        With selectionMask_array(0)
            .Type = UFConstants.UF_dimension_type
            .Subtype = 0
            .SolidBodySubtype = 0
        End With

        resp = ui.SelectionManager.SelectTaggedObjects(prompt, message, _
            scope, selAction, includeFeatures, keepHighlighted, selectionMask_array, obj)
        If resp = Selection.Response.ObjectSelected Or _
           resp = Selection.Response.ObjectSelectedByName Then
            Return Selection.Response.Ok
        Else
            Return Selection.Response.Cancel
        End If
    End Function

    Public Function GetUnloadOption(ByVal dummy As String) As Integer
        'Unloads the image immediately after execution within NX
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately
    End Function

End Module
